/**
 * @author Ulrich Schregenberger
 * @title Roulette Statistics
 * @version 1.0
 * @year 2009
 */

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.*;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;

import java.util.*;


class Roulette extends JFrame
{	
	private static final long serialVersionUID = 1L;
	
	JTextField budgetField,betField,autoAlternate,autoBet,autoRounds,autoGoal,autoSessions;
	
	JTextPane pane;
	Document doc;
	
	RouletteNumbers rouletteNumbers = new RouletteNumbers();
	SimpleAttributeSet set0,set1,set2,set3,set4,set5,set6,set7,set8,set9;
	BarChart bar1,bar2,bar3,bar4;
	
	JButton one,two,five,ten,twentyfive,hundred,last,clear,doubleBet,red,black,partage,prison,next,spin,statistics,reset,help;
	JRadioButton rRed,rBlack,rGoal,rRounds,rCol,rAlter,rRand;
	JCheckBox limit;
	
	List<Integer> list1,list2;
	
	boolean bLose = false;
	boolean bSubtractBetNext = false;
	boolean bLock = false;
	boolean bStatistics = false;
	
	int countRounds = 1;
	int bLoseCounter = 0;
	int budget = 0;
	int bet = 0;
	int lastBet = 0;
	int budgetReset = 0;	
	int color = 999;
	int lastAutoBet = 0;
	int betSwitch = 0;
	int statCountRed = 0;
	int statCountBlack = 0;
	int statCountZero = 0;
	int statCountWin = 0;
	int statCountLose = 0;
	int statCountPWin = 0;
	int statCountPart = 0;
	int sessions = 1;
	int alternateAmount = 1;
	int defaultBetAmount = 5;
	int betAmount = 5;	
	int rounds = 20;	
	int prisontimes = 0;	
	int roundcounter = 0;	
	int moneygoal = 1200;
	int startingCol = 1;	
	int totalGewinn = 0;
	int totalVerlust = 0;
	int totalResult = 0;
	int limitN = 0;
	int sieg = 0;
	int mode = 1;	
	
	public Roulette()
	{
		createGUI();
		init();		
		
		output("Round\tYour bet\tRoulette\tResult\tChange\tBudget\n",set0);
		output(countRounds+"",set0);
	}
	
	public void createGUI()
	{
		// for images
		ClassLoader cls = this.getClass().getClassLoader();
		
		// initialize list2
		list2 = new LinkedList<Integer>();
		
		// create GUI
		JPanel panel = new JPanel();
		JPanel panel1 = new JPanel();
		JPanel panel2 = new JPanel();
		JPanel panel3 = new JPanel();
		
		budgetField = new JTextField();
		budgetField.setEditable(true);
		budgetField.addKeyListener(new KL2());
		budgetField.setPreferredSize(new Dimension(170,40));
		budgetField.setText(""+budget);
		budgetField.setBackground(new Color(255,248,207));
		budgetField.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		budgetField.setFont(new Font("Arial",Font.PLAIN,44));
				
		betField = new JTextField();
		betField.setEditable(false);
		betField.setText(""+bet);
		betField.setBackground(new Color(184,207,229));
		betField.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		betField.setFont(new Font("Arial",Font.PLAIN,28));
		
		red = new JButton();
		red.setActionCommand("Red");
		red.setPreferredSize(new Dimension(80,60));
		red.setBackground(new Color(238,238,238));
		red.addActionListener(new AL2());
		black = new JButton();
		black.setActionCommand("Black");
		black.setPreferredSize(new Dimension(80,60));
		black.setBackground(new Color(238,238,238));
		black.addActionListener(new AL2());
		
		red.setIcon(new ImageIcon(cls.getResource("red.png")));
		red.setPressedIcon(new ImageIcon(cls.getResource("redb.png")));	
		black.setIcon(new ImageIcon(cls.getResource("black.png")));
		black.setPressedIcon(new ImageIcon(cls.getResource("blackb.png")));
		
		red.setBorder(null);
		black.setBorder(null);
		red.setContentAreaFilled(false);
		black.setContentAreaFilled(false);
		
		spin = new JButton();
		spin.setIcon(new ImageIcon(cls.getResource("spin.png")));
		spin.setPressedIcon(new ImageIcon(cls.getResource("spinb.png")));
		spin.setActionCommand("Spin");
		spin.setPreferredSize(new Dimension(143,143));
		spin.setBackground(new Color(238,238,238));
		spin.addActionListener(new AL2());
		spin.setBorder(null);
		// disables blue hover on mouseclick
		spin.setContentAreaFilled(false);
		
		one = new JButton();
		two = new JButton();
		five = new JButton();
		ten = new JButton();
		twentyfive = new JButton();
		hundred = new JButton();
		
		one.setActionCommand("1");
		two.setActionCommand("2");
		five.setActionCommand("5");
		ten.setActionCommand("10");
		twentyfive.setActionCommand("25");
		hundred.setActionCommand("100");
		
		one.setIcon(new ImageIcon(cls.getResource("1.png")));
		one.setPressedIcon(new ImageIcon(cls.getResource("1b.png")));
		two.setIcon(new ImageIcon(cls.getResource("2.png")));
		two.setPressedIcon(new ImageIcon(cls.getResource("2b.png")));
		five.setIcon(new ImageIcon(cls.getResource("5.png")));
		five.setPressedIcon(new ImageIcon(cls.getResource("5b.png")));
		ten.setIcon(new ImageIcon(cls.getResource("10.png")));
		ten.setPressedIcon(new ImageIcon(cls.getResource("10b.png")));
		twentyfive.setIcon(new ImageIcon(cls.getResource("25.png")));
		twentyfive.setPressedIcon(new ImageIcon(cls.getResource("25b.png")));
		hundred.setIcon(new ImageIcon(cls.getResource("100.png")));
		hundred.setPressedIcon(new ImageIcon(cls.getResource("100b.png")));
		
		one.setBorder(null);
		two.setBorder(null);
		five.setBorder(null);
		ten.setBorder(null);
		twentyfive.setBorder(null);
		hundred.setBorder(null);
		one.setContentAreaFilled(false);
		two.setContentAreaFilled(false);
		five.setContentAreaFilled(false);
		ten.setContentAreaFilled(false);
		twentyfive.setContentAreaFilled(false);
		hundred.setContentAreaFilled(false);
		
		Dimension dim1 = new Dimension(53,53);
		one.setPreferredSize(dim1);
		two.setPreferredSize(dim1);
		five.setPreferredSize(dim1);
		ten.setPreferredSize(dim1);
		twentyfive.setPreferredSize(dim1);
		hundred.setPreferredSize(dim1);
		
		one.addActionListener(new AL1());
		two.addActionListener(new AL1());
		five.addActionListener(new AL1());
		ten.addActionListener(new AL1());
		twentyfive.addActionListener(new AL1());
		hundred.addActionListener(new AL1());

		// configure titledBorder
		Color color1 = new Color(122,138,153);
		Font fx = new Font("Arial",Font.PLAIN,10);
		int lineWidth = 1;
		int lineMode = 0;
		
		autoBet = new JTextField();
		autoBet.setEditable(true);
		autoBet.addKeyListener(new KL4());
		autoBet.setPreferredSize(new Dimension(40,28));
		autoBet.setText(""+defaultBetAmount);
		autoBet.setBackground(new Color(238,238,238));
		autoBet.setBorder(BorderFactory.createLineBorder(color1));
		autoAlternate = new JTextField();
		autoAlternate.setEditable(true);
		autoAlternate.addKeyListener(new KL5());
		autoAlternate.setPreferredSize(new Dimension(40,28));
		autoAlternate.setText(""+alternateAmount);
		autoAlternate.setBackground(new Color(238,238,238));
		autoAlternate.setBorder(BorderFactory.createLineBorder(color1));
		autoRounds = new JTextField();
		autoRounds.setEditable(true);
		autoRounds.addKeyListener(new KL6());
		autoRounds.setPreferredSize(new Dimension(80,28));
		autoRounds.setText(""+rounds);
		autoRounds.setBackground(new Color(238,238,238));
		autoRounds.setBorder(BorderFactory.createLineBorder(color1));
		autoGoal = new JTextField();
		autoGoal.setEditable(true);
		autoGoal.addKeyListener(new KL3());
		autoGoal.setPreferredSize(new Dimension(40,28));
		autoGoal.setText(""+budget);
		autoGoal.setBackground(new Color(238,238,238));
		autoGoal.setBorder(BorderFactory.createLineBorder(color1));
		autoSessions = new JTextField();
		autoSessions.setEditable(true);
		autoSessions.addKeyListener(new KL1());
		autoSessions.setPreferredSize(new Dimension(40,28));
		autoSessions.setText(""+sessions);
		autoSessions.setBackground(new Color(238,238,238));
		autoSessions.setBorder(BorderFactory.createLineBorder(color1));
		
		Dimension dim2 = new Dimension(82,31);
		
		last = new JButton();
		last.setActionCommand("Last");
		last.setPreferredSize(dim2);
		last.addActionListener(new AL2());
		doubleBet = new JButton();
		doubleBet.setActionCommand("Double");
		doubleBet.setPreferredSize(dim2);
		doubleBet.addActionListener(new AL2());
		partage = new JButton();
		partage.setPreferredSize(dim2);
		partage.setActionCommand("La Partage");
		partage.addActionListener(new AL2());
		partage.setEnabled(false);
		prison = new JButton();
		prison.setActionCommand("En Prison");
		prison.setPreferredSize(dim2);
		prison.addActionListener(new AL2());
		prison.setEnabled(false);
		statistics = new JButton();
		statistics.setActionCommand("Statistics");
		statistics.addActionListener(new AL2());
		statistics.setPreferredSize(dim2);
		help = new JButton();
		help.setActionCommand("Help");
		help.addActionListener(new AL2());
		help.setPreferredSize(new Dimension(80,65));
		next = new JButton();
		next.setActionCommand("Next");
		next.addActionListener(new AL2());
		next.setPreferredSize(new Dimension(82,31));
		next.setBackground(new Color(238,238,238));
		next.setForeground(new Color(0,0,0));		
		reset = new JButton();
		reset.setActionCommand("Reset");
		reset.setPreferredSize(new Dimension(80,65));
		reset.addActionListener(new AL2());
		clear = new JButton("Clear");
		clear.addActionListener(new AL2());		
		// size of clear and betField
		clear.setPreferredSize(new Dimension(65,30));
		betField.setPreferredSize(new Dimension(100,30));
		
		reset.setIcon(new ImageIcon(cls.getResource("reset.png")));
		reset.setPressedIcon(new ImageIcon(cls.getResource("resetb.png")));
		last.setIcon(new ImageIcon(cls.getResource("f1a.png")));
		last.setPressedIcon(new ImageIcon(cls.getResource("f1b.png")));
		doubleBet.setIcon(new ImageIcon(cls.getResource("f2a.png")));
		doubleBet.setPressedIcon(new ImageIcon(cls.getResource("f2b.png")));
		partage.setIcon(new ImageIcon(cls.getResource("f3a.png")));
		partage.setPressedIcon(new ImageIcon(cls.getResource("f3b.png")));
		prison.setIcon(new ImageIcon(cls.getResource("f4a.png")));
		prison.setPressedIcon(new ImageIcon(cls.getResource("f4b.png")));
		statistics.setIcon(new ImageIcon(cls.getResource("f5a.png")));
		statistics.setPressedIcon(new ImageIcon(cls.getResource("f5b.png")));
		next.setIcon(new ImageIcon(cls.getResource("f6a.png")));
		next.setPressedIcon(new ImageIcon(cls.getResource("f6b.png")));
		help.setIcon(new ImageIcon(cls.getResource("help.png")));
		help.setPressedIcon(new ImageIcon(cls.getResource("helpb.png")));		
		
		statistics.setBorder(null);
		partage.setBorder(null);
		prison.setBorder(null);
		last.setBorder(null);
		reset.setBorder(null);
		doubleBet.setBorder(null);
		help.setBorder(null);
		next.setBorder(null);
		help.setContentAreaFilled(false);
		last.setContentAreaFilled(false);
		doubleBet.setContentAreaFilled(false);
		partage.setContentAreaFilled(false);
		prison.setContentAreaFilled(false);
		statistics.setContentAreaFilled(false);
		next.setContentAreaFilled(false);
		reset.setContentAreaFilled(false);
				
		// create textpane
		pane = new JTextPane();
		doc = pane.getStyledDocument();
	    JScrollPane scrollPane = new JScrollPane(pane);
	    // determine size or else Alt+Tab,Minimizing,etc make bugs
	    scrollPane.setPreferredSize(new Dimension(434,457));
		
	    set1 = new SimpleAttributeSet(); // default,black
	    set0 = new SimpleAttributeSet();
	    StyleConstants.setItalic(set0,true);
	    StyleConstants.setForeground(set0,Color.lightGray); // italic,grey
	    set2 = new SimpleAttributeSet();
	    StyleConstants.setBold(set2,true);
	    StyleConstants.setForeground(set2,Color.RED); // bold,red
	    set3 = new SimpleAttributeSet();
	    StyleConstants.setBold(set3,true);
	    StyleConstants.setForeground(set3,Color.BLACK); // bold,black
	    set4 = new SimpleAttributeSet();
	    StyleConstants.setFontSize(set4,16);
	    StyleConstants.setBold(set4,true);
	    StyleConstants.setForeground(set4,new Color(0,200,0)); // big,bold,darkred
	    set5 = new SimpleAttributeSet();
	    StyleConstants.setFontSize(set5,16);
	    StyleConstants.setBold(set5,true);
	    StyleConstants.setForeground(set5,new Color(255,155,0)); // big,bold,orange
	    set6 = new SimpleAttributeSet();
	    StyleConstants.setBold(set6,true);
	    StyleConstants.setForeground(set6,new Color(0,210,90)); // bold,green-blue
	    set7 = new SimpleAttributeSet();
	    StyleConstants.setFontSize(set7,16);
	    StyleConstants.setBold(set7,true);
	    StyleConstants.setForeground(set7,new Color(255,215,0));// big,bold,darkyellow
	    set8 = new SimpleAttributeSet();
	    StyleConstants.setFontSize(set8,16);
	    StyleConstants.setBold(set8,true);
	    StyleConstants.setForeground(set8,new Color(195,215,0)); // big,bold,green-yellow
	    set9 = new SimpleAttributeSet();
	    StyleConstants.setBold(set9,true);
	    StyleConstants.setForeground(set9,new Color(0,0,0)); // bold,black
	    
	    rRounds = new JRadioButton("Rounds",true);
	    rGoal = new JRadioButton("Goal",false);
	    ButtonGroup gPlayMode = new ButtonGroup();
	    gPlayMode.add(rRounds);
	    gPlayMode.add(rGoal);
	    rRounds.addItemListener(UrGoal);
	    rGoal.addItemListener(UrGoal);
	    
	    rRed = new JRadioButton("Red",true);
	    rBlack = new JRadioButton("Black",false);
	    ButtonGroup gColor = new ButtonGroup();
	    gColor.add(rRed);
	    gColor.add(rBlack);
	    rRed.addItemListener(UrColor);
	    rBlack.addItemListener(UrColor);
	    
	    rCol = new JRadioButton("1 Color",true);
	    rAlter = new JRadioButton("Alternate",false);
	    rRand = new JRadioButton("Random",false);
	    ButtonGroup gBetMode = new ButtonGroup();
	    gBetMode.add(rCol);
	    gBetMode.add(rRand);
	    gBetMode.add(rAlter);
	    rCol.addItemListener(UrBet);
	    rRand.addItemListener(UrBet);
	    rAlter.addItemListener(UrBet);
	    
	    limit = new JCheckBox("Limit Money",true);
	    limit.setPreferredSize(new Dimension(120,34));
	    limit.addItemListener(UrLimit);
	    
	    // create subpanels
	    GridLayout grid1 = new GridLayout(5,2,5,5);
		JPanel inner1 = new JPanel();
		inner1.setPreferredSize(new Dimension(170,140));
		inner1.setLayout(grid1);
		inner1.add(autoGoal);
		inner1.add(new JLabel("Money Goal"));
		inner1.add(autoRounds);
		inner1.add(new JLabel("Rounds"));
		inner1.add(autoSessions);
		inner1.add(new JLabel("Sessions"));
		inner1.add(autoBet);
		inner1.add(new JLabel("Default Bet"));
		inner1.add(autoAlternate);
		inner1.add(new JLabel("Alternation"));
		
		GridLayout grid2 = new GridLayout(2,1,5,5);
		JPanel in2a = new JPanel();
		in2a.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(color1,lineWidth),"Alternate Start / 1 Color",0,lineMode,fx,color1));// font,col
		in2a.setPreferredSize(new Dimension(125,66));
		in2a.setLayout(grid2);
		in2a.add(rRed);
		in2a.add(rBlack);
		
		GridLayout grid3 = new GridLayout(3,1,5,5);
		JPanel in3a = new JPanel();
		in3a.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(color1,lineWidth),"Bet Mode",0,lineMode,fx,color1));
		in3a.setPreferredSize(new Dimension(120,98));
		in3a.setLayout(grid3);
		in3a.add(rCol);
		in3a.add(rRand);
		in3a.add(rAlter);
		
		GridLayout grid4 = new GridLayout(2,1,5,5);
		JPanel in2b = new JPanel();
		in2b.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(color1,lineWidth),"Play Mode",0,lineMode,fx,color1));
		in2b.setPreferredSize(new Dimension(125,66));
		in2b.setLayout(grid4);
		in2b.add(rRounds);
		in2b.add(rGoal);
		
		JPanel inner2 = new JPanel();
		JPanel inner3 = new JPanel();
		inner2.add(in2b);
		inner2.add(in2a);
		inner2.setPreferredSize(new Dimension(125,140));
		inner3.add(limit);
		inner3.add(in3a);
		inner3.setPreferredSize(new Dimension(120,140));
		
		// (name,modus)
		bar3 = new BarChart("",3);		
		bar3.chartPanel.setPreferredSize(new Dimension(270,140));
		bar4 = new BarChart("",4);	
		bar4.chartPanel.setPreferredSize(new Dimension(270,140));
		bar2 = new BarChart("",2);		
		bar2.chartPanel.setPreferredSize(new Dimension(270,166));
		bar1 = new BarChart("",1);		
		bar1.chartPanel.setPreferredSize(new Dimension(270,142));
	    
	    JSeparator sep = new JSeparator();
		sep.setPreferredSize(new Dimension(170,10));
		sep.setForeground(new Color(238,238,238));
		sep.setBackground(new Color(238,238,238));		
		JSeparator sep2 = new JSeparator();
		sep2.setPreferredSize(new Dimension(170,1));
		sep2.setForeground(new Color(238,238,238));
		sep2.setBackground(new Color(238,238,238));
	    
		// east
		panel1.add(budgetField);
		panel1.add(betField);
		panel1.add(clear);
		panel1.add(one);
		panel1.add(two);
		panel1.add(five);
		panel1.add(ten);
		panel1.add(twentyfive);
		panel1.add(hundred);
		panel1.add(red);
		panel1.add(black);
		panel1.add(spin);
		panel1.add(sep);
		panel1.add(last);
		panel1.add(doubleBet);
		panel1.add(partage);
		panel1.add(prison);
		panel1.add(statistics);
		panel1.add(next);
		panel1.add(sep2);
		panel1.add(reset);
		panel1.add(help);
		
		// west
		panel2.add(bar4.chartPanel);
		panel2.add(bar3.chartPanel);		
		panel2.add(bar2.chartPanel);
		panel2.add(bar1.chartPanel);
		
		// center
		panel3.add(scrollPane);
		panel3.add(inner1);
		panel3.add(inner3);
		panel3.add(inner2);
		
		panel2.setPreferredSize(new Dimension(280,690));// charts
		panel3.setPreferredSize(new Dimension(440,690));// textfield
		panel1.setPreferredSize(new Dimension(180,690));// manual mode
		panel.setLayout(new BorderLayout());
		panel.add(panel2,BorderLayout.WEST);
		panel.add(panel3,BorderLayout.CENTER);
		panel.add(panel1,BorderLayout.EAST);
		add(panel);
		
		addWindowListener(new WL());
	}
	
	public void output(String str, SimpleAttributeSet sas)
	{
    	try
    	{
    		doc.insertString(doc.getLength(),str,sas);
    	}
    	catch (BadLocationException ble)
    	{
    		System.out.println("BadLocationException happened!");
    	}
  	}
	
	public void init()
	{		
		if(budgetReset != 0)
			budget = budgetReset; // reset to user budget
		else
		{
			budget = 1000; // initiate a budget of 1000 on startup
			budgetReset = 1000;
		}
		
		bet = 0;
		betField.setText(""+bet);
		
		color = 999;
		
		budgetField.setText(""+budget);		
		pane.setText("");
		
		// also reset lastBet value
		lastBet = 0;
		
		autoGoal.setText(""+moneygoal);
		
		enableButtons();
		
		bLock = false;
		
		// activate next button
		next.setEnabled(true);
		
		//reset all bars
		resetLists();
	}
	
	ItemListener UrGoal = new ItemListener()
	{
		public void itemStateChanged(ItemEvent dL)
	   	{
	    	if(rRounds.isSelected()==true)
			{
//				output("> Play fixed rounds\n",set1);
				sieg = 0;
			}
	    	else if(rGoal.isSelected()==true)
			{
//	    		output("> Play on win!\n",set1);
	    		sieg = 1;
			}
	   	}
	};
	
	ItemListener UrBet = new ItemListener()
	{
		public void itemStateChanged(ItemEvent dL)
	   	{
	    	if(rCol.isSelected()==true)
			{
//	    		output("> Bet black only!\n",set1);
	    		mode = 1;
			}
	    	else if(rRand.isSelected()==true)
			{
//	    		output("> Bet randomly!\n",set1);
	    		mode = 2;
			}
	    	else if(rAlter.isSelected()==true)
			{
//	    		output("> Bet alternating!\n",set1);
	    		mode = 3;
			}
	   	}
	};
	
	ItemListener UrColor = new ItemListener()
	{
		public void itemStateChanged(ItemEvent dL)
	   	{
	    	if(rRed.isSelected()==true)
			{
//				output("> Startcolor red selected\n",set1);
				startingCol = 1;
			}
	    	else if(rBlack.isSelected()==true)
			{
//	    		output("> Startcolor black selected\n",set1);
	    		startingCol = 2;
			}
	   	}
	};
	
	ItemListener UrLimit = new ItemListener()
	{
		public void itemStateChanged(ItemEvent dL)
	   	{
	    	if(limit.isSelected()== true)
			{
//				output("> Money limit activated\n",set1);
				limitN = 0;
			}
	    	else
			{
//	    		output("> Money limit deactivated\n",set1);
	    		limitN = 1;
			}
	   	}
	};	
	
	class WL extends WindowAdapter
	{
		public void windowClosing(WindowEvent we)
		{
		    System.exit(0);
		}
	}
	
	class KL1 implements KeyListener
	{
		public void keyTyped(KeyEvent ke)
		{}
		public void keyReleased(KeyEvent ke)
		{
			try
			{
				// change your budget
				sessions = Integer.parseInt(autoSessions.getText());
//				output("> Sessions changed to "+sessions+"\n",set1);
			}
			catch(NumberFormatException nfe)
			{
//				output("> Please type in numbers only!\n",set1);
			}
		}
		public void keyPressed(KeyEvent ke)
		{}
	}
	
	class KL2 implements KeyListener
	{
		public void keyTyped(KeyEvent ke)
		{}
		public void keyReleased(KeyEvent ke)
		{
			try
			{
				// change your budget
				budget = Integer.parseInt(budgetField.getText());
//				output("> Budget changed to "+budget+"\n",set1);
				
				// the new value acts as new reset point
				budgetReset = budget;
			}
			catch(NumberFormatException nfe)
			{
//				output("> Please type in numbers only!\n",set1);
			}
		}
		public void keyPressed(KeyEvent ke)
		{}
	}
	
	class KL3 implements KeyListener
	{
		public void keyTyped(KeyEvent ke)
		{}
		public void keyReleased(KeyEvent ke)
		{
			try
			{
				// change your goal
				moneygoal = Integer.parseInt(autoGoal.getText());
//				output("> Moneygoal changed to "+moneygoal+"\n",set1);
			}
			catch(NumberFormatException nfe)
			{
//				output("> Please type in numbers only!\n",set1);
			}
		}
		public void keyPressed(KeyEvent ke)
		{}
	}
	
	class KL4 implements KeyListener
	{
		public void keyTyped(KeyEvent ke)
		{}
		public void keyReleased(KeyEvent ke)
		{
			try
			{
				// change your betAmount on the fly
				betAmount = Integer.parseInt(autoBet.getText());
				defaultBetAmount = Integer.parseInt(autoBet.getText());
//				output("> Bet & default bet changed to "+betAmount+"\n",set1);
			}
			catch(NumberFormatException nfe)
			{
//				output("> Please type in numbers only!\n",set1);
			}
		}
		public void keyPressed(KeyEvent ke)
		{}
	}
	
	class KL5 implements KeyListener
	{
		public void keyTyped(KeyEvent ke)
		{}
		public void keyReleased(KeyEvent ke)
		{
			try
			{
				// change your betAmount on the fly
				alternateAmount = Integer.parseInt(autoAlternate.getText());
//				output("> Alternation changed to "+alternateAmount+"\n",set1);
			}
			catch(NumberFormatException nfe)
			{
//				output("> Please type in numbers only!\n",set1);
			}
		}
		public void keyPressed(KeyEvent ke)
		{}
	}
	
	class KL6 implements KeyListener
	{
		public void keyTyped(KeyEvent ke)
		{}
		public void keyReleased(KeyEvent ke)
		{
			try
			{
				// change your betAmount on the fly
				rounds = Integer.parseInt(autoRounds.getText());
//				output("> Rounds changed to "+rounds+"\n",set1);
			}
			catch(NumberFormatException nfe)
			{
//				output("> Please type in numbers only!\n",set1);
			}
		}
		public void keyPressed(KeyEvent ke)
		{}
	}
	
	class AL1 implements ActionListener
	{
		public void actionPerformed(ActionEvent ae)
		{
			bet = bet+Integer.parseInt(ae.getActionCommand());
			betField.setText(""+bet);
			budget = Integer.parseInt(budgetField.getText())-Integer.parseInt(ae.getActionCommand());
			budgetField.setText(""+budget);
		}
	}
	
	class AL2 implements ActionListener
	{
		public void actionPerformed(ActionEvent ae)
		{
			String label = ae.getActionCommand();
			
			if(label.equals("En Prison"))
			{
				//reset bLock
				bLock = false;
								
				// make new line
				output("\n",set1);
				
				// end previous round.. and start new one
				countRounds++;				
				output(countRounds+"",set0);		
				
//				output("> En Prison\n",set1);
				prison.setEnabled(false);
				partage.setEnabled(false);
				spin.setEnabled(true);
				
				prisontimes = 1;
			}
			if(label.equals("Red"))
			{
				output("\tRED\n",set2);
				color = 1;
			}
			if(label.equals("Black"))
			{
				output("\tBLACK\n",set3);
				color = 2;
			}			
			
			if(label.equals("La Partage"))
			{
				int halfBet = 0;
				
				halfBet = bet/2;
				
				int  lostHalf = bet-halfBet;
				output("\t-"+lostHalf,set1);
				
				budget = budget+halfBet;
				budgetField.setText(""+budget);
				
				output("\t"+budget+"\n",set1);
				
				// only if bet>0 und color!=999 do following
				if((bet > 0) && (color != 999))
				{
					statCountPart++;
					
					// la partage must be entered in bar immediately, or else it would
					// only be shown at next "spin"
					bar1.Ddataset.setValue(statCountPart,bar1.series8,bar1.category1);
				}
					
				bet = 0;
				betField.setText(""+bet);
				
//				output("> La Partage\n> Half bet returned: "+halfBet+"\n",set1);
				
				enableButtons();
				
				//reset bLock
				bLock = false;
				
				// if "false" -> on clicking "next" will ignore the amount
				// of money in bet field and reset the budget value
				bSubtractBetNext = false;
				
				// end round afterwards... and start new one
				countRounds++;					
				output(countRounds+"",set0);				
			}
			
			if(label.equals("Spin"))
			{	
								
				bSubtractBetNext = true;				
				
				Random generator = new Random();
				int random = generator.nextInt(37); // numbers from 0-36
				int number = rouletteNumbers.list.get(random);
				
				output("\t\t",set1);
				
				if(number == 1)
				{
					output("RED",set2);
					statCountRed++;
				}
				else if(number == 2)
				{
					output("BLACK",set3);
					statCountBlack++;
				}
				else
				{
					output("ZERO",set6);
					statCountZero++;
				}
				
				// print exact number
//				output(" ("+random+")",set1);
				
				if((Integer.parseInt(betField.getText())==0)||(color==999))
					output("\n",set1);
				
				if(prisontimes == 1)
				{
					// Roulette hits color
					if(number == color)
					{
						// only if bet>0 und color!=999 do following
						if((bet > 0) && (color != 999))
						{
							statCountPWin++;
						}
						
						// always output
						output("\tUNLOCK\n",set8);
						
						// if pressed "next" afterwards the unlocked bet money
						// will put back to your budget
						bSubtractBetNext = false;
					}
					else
					{		
						// always output
						output("\tLOSE",set5);
						output("\t-"+Integer.parseInt(betField.getText()),set1);					
						
						// only if bet>0 und color!=999 do following
						if((bet > 0) && (color != 999))
						{
							bet = 0;
							betField.setText(""+bet);
							
							output("\t"+budget+"\n",set1);		
							
							// also do normal Lose+1
							statCountLose++;
							
							bSubtractBetNext = false;
							
							// activate bLose+counter
							bLose = true;
							bLoseCounter++;
						}
					}
					
					// re-enable buttons
					enableButtons();
				}
				
				// prisontimes == 0
				else
				{
					// save last bet
					if(Integer.parseInt(betField.getText()) != 0)
						lastBet = Integer.parseInt(betField.getText());
									
					if(number == color)
					{
						if((bet > 0) && (color != 999))
						{
							output("\tWIN",set4);
							output("\t+"+Integer.parseInt(betField.getText()),set1);
							
							statCountWin++;
							
							if(bLose == true)
							{
								// entry in chart
								int tempEintrag = 0;
								tempEintrag = list1.get(bLoseCounter);
								tempEintrag = tempEintrag+1;
								list1.set(bLoseCounter,tempEintrag);
								bar2.Ddataset.setValue(tempEintrag,bar2.seriesN[bLoseCounter],bar2.category1);
								// deactivate bLose+counter 
								bLose = false;
								// reset Lose-counter
								bLoseCounter = 0;
							}
						}
						
						bSubtractBetNext = false;
						
						budget = Integer.parseInt(budgetField.getText())+2*Integer.parseInt(betField.getText());
						budgetField.setText(""+budget);		
						
						if((bet > 0) && (color != 999))
							output("\t"+budget+"\n",set1);						
						
						// reset some settings
						bet = 0;
						betField.setText(""+bet);
					}
					else if ((number != color)&&(number != 0))
					{			
						// only if bet>0 und color!=999 do following
						if((bet > 0) && (color != 999))
						{
							output("\tLOSE",set5);							
							output("\t-"+Integer.parseInt(betField.getText()),set1);
							output("\t"+budget,set1);		
							
							statCountLose++;
							
							bSubtractBetNext = false;
							
							// activate bLose+counter
							bLose = true;
							bLoseCounter++;
																										
						}
						else // e.g. only a money bet chosen, but no color
						{
							budget = Integer.parseInt(budgetField.getText())+Integer.parseInt(betField.getText());
							budgetField.setText(""+budget);
							
							bSubtractBetNext = false;
						}
						
						// reset some settings
						bet = 0;
						betField.setText(""+bet);
						
						output("\n",set1);		
					}
					else // number = 0
					{
						// only if bet>0 und color!=999 do following
						if((bet > 0) && (color != 999))
						{
							output("\tLOCK",set7);
													
							if(bet == 1)
								betSwitch = 1; // if bet is 1 coin only, it cannot be divided
							
							disableButtons();
							
							bLock = true;
						}
						else
						{
							budget = Integer.parseInt(budgetField.getText())+Integer.parseInt(betField.getText());
							budgetField.setText(""+budget);
							
							// reset some settings
							bet = 0;
							betField.setText(""+bet);
							
							bSubtractBetNext = false;
						}
					}
				}
				
				
				// set statistics
				bar1.Ddataset.setValue(statCountRed,bar1.series1,bar1.category1);
				bar1.Ddataset.setValue(statCountBlack,bar1.series2,bar1.category1);
				bar1.Ddataset.setValue(statCountZero,bar1.series3,bar1.category1);
				bar1.Ddataset.setValue(statCountWin,bar1.series4,bar1.category1);
				bar1.Ddataset.setValue(statCountLose,bar1.series5,bar1.category1);
				bar1.Ddataset.setValue(statCountPWin,bar1.series7,bar1.category1);
				
				if(bLock == true)
				{
					//output(countRounds+"",set0);
				}
				else
				{
					// roundcounter
					countRounds++;
					
					output(countRounds+"",set0);
				}
			}
			
			if(label.equals("Last"))
			{				
				if(lastBet == 0)
				{
//					output("> No last round available or last bet was 0\n",set0);
				}
				else
				{					
					// clear previous bet first
					budget = Integer.parseInt(budgetField.getText())+Integer.parseInt(betField.getText());
					budgetField.setText(""+budget);
					bet = 0;
					betField.setText(""+bet);
					
					// set last bet as new bet
					bet = lastBet;						
					betField.setText(""+lastBet);
					budget = Integer.parseInt(budgetField.getText())-bet;
					budgetField.setText(""+budget);
					
				}
			}
			
			if(label.equals("Reset"))
			{
				// reset all settings
				init();
//				output("> All reset\n",set1);
				
				// reset all counters too
				resetCounters();
				
				// stop losecounter
				if(bLose == true)
				{
					bLose = false;
					// reset Lose-counter
					bLoseCounter = 0;
				}
				
				// reset roundcounter
				countRounds = 1;
				output("Round\tYour bet\tRoulette\tResult\tChange\tBudget\n",set0);
				output(countRounds+"",set0);
			}
			
			if(label.equals("Clear"))
			{				
				budget = Integer.parseInt(budgetField.getText())+Integer.parseInt(betField.getText());
				budgetField.setText(""+budget);
				
				// clear bet
				bet = 0;
				betField.setText(""+bet);
				
//				output("> Bet cleared\n",set1);
			}
			
			if(label.equals("Double"))
			{
				int tmpDouble = Integer.parseInt(betField.getText());				
				bet = tmpDouble*2;
				betField.setText(""+bet);
				
				budget = Integer.parseInt(budgetField.getText())-tmpDouble;
				budgetField.setText(""+budget);
				
//				output("> Active bet doubled\n",set1);
			}
			
			if(label.equals("Next"))
			{				
				// important function that resets current money bet subtracted from budget if 
				// "next" is clicked
				if(bSubtractBetNext == false)
				{
					budget = Integer.parseInt(budgetField.getText())+Integer.parseInt(betField.getText());
					budgetField.setText(""+budget);
				}					
				
				if(budget > budgetReset)	// earned more
				{
					int tempEintragA = 0;
					tempEintragA = list2.get(0);
					tempEintragA = tempEintragA+1;
					list2.set(0,tempEintragA);
					bar3.Ddataset.setValue(tempEintragA,bar3.seriesMore,bar3.category1);
					
					int tempTotalG = Math.abs(budgetReset-budget);
					totalGewinn = tempTotalG+totalGewinn;
					bar4.Ddataset.setValue(totalGewinn,bar4.earned,bar4.category1);
				}
				else if (budget == budgetReset)//even
				{
					int tempEintragX = 0;
					tempEintragX = list2.get(2);
					tempEintragX = tempEintragX+1;
					list2.set(2,tempEintragX);
					bar3.Ddataset.setValue(tempEintragX,bar3.seriesEven,bar3.category1);
				}	
				else	// less
				{
					int tempEintragB = 0;
					tempEintragB = list2.get(1);
					tempEintragB = tempEintragB+1;
					list2.set(1,tempEintragB);
					bar3.Ddataset.setValue(tempEintragB,bar3.seriesLess,bar3.category1);
					
					int tempTotalV = Math.abs(budgetReset-budget);
					totalVerlust = tempTotalV+totalVerlust;
					bar4.Ddataset.setValue(totalVerlust,bar4.lost,bar4.category1);
				}
				
				output("\n",set1);
//				output("\n\t\tSession end - Budget: "+budgetField.getText()+"\n",set1);
				
				// if last round was a LOSE don't forget to add values in charts,
				// else it only happens with "WIN"
				if(bLose == true)
				{
					// entry in chart
					int tempEintrag = 0;
					tempEintrag = list1.get(bLoseCounter);
					tempEintrag = tempEintrag+1;
					list1.set(bLoseCounter,tempEintrag);
					bar2.Ddataset.setValue(tempEintrag,bar2.seriesN[bLoseCounter],bar2.category1);
					// deactivate bLose+counter 
					bLose = false;
					// reset Lose-counter
					bLoseCounter = 0;
				}
				
				// calculate overall result
				totalResult = totalGewinn-totalVerlust;
				bar4.Ddataset.setValue(totalResult,bar4.result,bar4.category1);
				
				// reset some settings
				budget = budgetReset;
				budgetField.setText(""+budget);
				bet = 0;
				betField.setText(""+bet);
				
				bSubtractBetNext = false;
				
				// reset LastBet
				lastBet = 0;
				
				// reset color
				color = 999;
				
				output("__________________________________________________________\n",set0);
				
				// reset roundcounter
				countRounds = 1;
				output(countRounds+"",set0);
			}
			
			if(label.equals("Help"))
			{
				new SubDialog();
			}
			
			if(label.equals("Statistics"))
			{				
				spin.setEnabled(false);
				next.setEnabled(false);
				
				pane.setText("");
				
				//reset listbars			
				resetLists();
				
				// reset roundounter
				roundcounter = 0;
				
				//reset variables for bar4
				totalGewinn = 0;
				totalVerlust = 0;
				totalResult = 0;
				
				// reset farbcounter
				resetCounters();
								
				for(int j=0;j<sessions;j++)
				{
					calculate();
					
					// reset
					bStatistics = true;
				}
				
				spin.setEnabled(false);
			}
			
			// automatically scroll to bottom
			positionCursor();
		}
	}
	
	public void positionCursor()
	{
		pane.setCaretPosition(pane.getDocument().getLength());
	}
	
	public void disableButtons()
	{
		one.setEnabled(false);
		two.setEnabled(false);
		five.setEnabled(false);
		ten.setEnabled(false);
		twentyfive.setEnabled(false);
		hundred.setEnabled(false);
		red.setEnabled(false);
		black.setEnabled(false);
		last.setEnabled(false);
		clear.setEnabled(false);
		doubleBet.setEnabled(false);
		next.setEnabled(false);
		spin.setEnabled(false);
		
		if(betSwitch == 1)
			partage.setEnabled(false);
		else
			partage.setEnabled(true);
		prison.setEnabled(true);
		
		betSwitch = 0;
	}
	
	public void enableButtons()
	{
		one.setEnabled(true);
		two.setEnabled(true);
		five.setEnabled(true);
		ten.setEnabled(true);
		twentyfive.setEnabled(true);
		hundred.setEnabled(true);
		red.setEnabled(true);
		black.setEnabled(true);
		last.setEnabled(true);
		clear.setEnabled(true);
		doubleBet.setEnabled(true);
		next.setEnabled(true);
		spin.setEnabled(true);
		
		partage.setEnabled(false);
		prison.setEnabled(false);
		
		prisontimes = 0;
	}
	
	public void resetCounters()
	{
		// reset farbcounter
		statCountRed = 0;
		statCountBlack = 0;
		statCountZero = 0;
		statCountWin = 0;
		statCountLose = 0;
		statCountPWin = 0;
		statCountPart = 0;
	}
	
	public void resetLists()
	{
		list1 = new LinkedList<Integer>();	
		
		if(list1!=null)
			list1.clear();
		if(list2!=null)
			list2.clear();
		
		//reset values2
		list2.add(0);
		list2.add(0);
		list2.add(0);	
		
		//reset bars
		bar1.Ddataset.setValue(0,bar1.series1,bar1.category1);
		bar1.Ddataset.setValue(0,bar1.series2,bar1.category1);
		bar1.Ddataset.setValue(0,bar1.series3,bar1.category1);
		bar1.Ddataset.setValue(0,bar1.series4,bar1.category1);
		bar1.Ddataset.setValue(0,bar1.series5,bar1.category1);
		bar1.Ddataset.setValue(0,bar1.series7,bar1.category1);
		bar1.Ddataset.setValue(0,bar1.series8,bar1.category1);		
		
		//reset bars
		for(int i=0;i<20;i++)
		{
			// fill with 0
			list1.add(0);
			//reset bar2
			bar2.Ddataset.setValue(0,bar2.seriesN[i],bar2.category1);
		}
		
		//reset bars
		bar3.Ddataset.setValue(0,bar3.seriesMore,bar3.category1);
		bar3.Ddataset.setValue(0,bar3.seriesEven,bar3.category1);
		bar3.Ddataset.setValue(0,bar3.seriesLess,bar3.category1);
		
		// bar4 reset
		bar4.Ddataset.setValue(0,bar4.earned,bar4.category1);
		bar4.Ddataset.setValue(0,bar4.lost,bar4.category1);
		bar4.Ddataset.setValue(0,bar4.result,bar4.category1);
		
		totalGewinn = 0;
		totalVerlust = 0;
		totalResult = 0;
	}
	
	public void init2()
	{
		if(budgetReset != 0)
			budget = budgetReset; // reset to user budget
		else
		{
			budget = 1000; // initiate a budget of 1000 on startup
			budgetReset = 1000;
		}
		
		bet = 0;
		betField.setText(""+bet);
		
		color = 999;
		
		budgetField.setText(""+budget);		
		
		if(this.roundcounter==0)
		{
			output("Round\tYour bet\tRoulette\tResult\tBudget\tNext bet\n",set0);
		}
		else
		{
			output("__________________________________________________________\n",set0);
		}
		
		
		// also reset lastBet value
		lastBet = 0;
		
		autoGoal.setText(""+moneygoal);
		
		enableButtons();
	}
	
	public void calculate()
	{
		init2();
		
		// duplicatiancounter
		int verdopplung = 0;
				
		// reset
		lastAutoBet = defaultBetAmount;
				
		int counter = 0; // counts how often each color was bet consecutively (for alternation)
		int startColor = startingCol;
		boolean lose = false;
		
		// if you play for a money goal, maximum rounds is 10000
		if(sieg == 1)
			rounds = 10000;
		else
			rounds = Integer.parseInt(autoRounds.getText());
		
		roundcounter = 0;
		boolean prisonloop = false;
		
		for(int j=0;j<rounds;j++)
		{
			roundcounter++;
			output(roundcounter+"\t",set1);
			
			Random generator = new Random();
			int random = generator.nextInt(37); // numbers from 0-36
			int number = rouletteNumbers.list.get(random);
			
			if(prisonloop == false)
			{				
				// if mode 1 is activated (1 Color) - do nothing
				
				// if mode 2 is activated (Random)
				if(mode == 2)
				{
					Random generator2 = new Random();
					int random2 = generator2.nextInt(2); // numbers from 0-36
					
					if(random2 == 0)
						startColor = 1;
					else
						startColor = 2;
				}
				// if mode 3 is activated (Alternating)
				if(mode == 3)
				{
					/*
					 *  - Alternate bet colors each round
					 *  - Skip Alternation if "En Prison"
					 */		
					if(startColor == 1)
					{				
						counter++;
						if(counter > alternateAmount)
						{
							counter = 1;
							startColor = 2;
						}	
					}
					else
					{
						counter++;
						if(counter > alternateAmount)
						{
							counter = 1;
							startColor = 1;
						}	
					}
				}
			}
			
			if(lose == false)
			{
				betAmount = defaultBetAmount;
			}
			else	//check if bet is still possible
			{
				if(limitN == 0)
				{
					if(budget-betAmount < 0)
					{
						// write loss in statistics
						if(verdopplung != 0)
						{
							int tempEintrag = 0;
							tempEintrag = list1.get(verdopplung);
							tempEintrag = tempEintrag+1;
							
							list1.set(verdopplung,tempEintrag);
							bar2.Ddataset.setValue(tempEintrag,bar2.seriesN[verdopplung],bar2.category1);
						}
						//reset verdopplung
						verdopplung = 0;
												
						output("Out of Money!\n",set0);
						break;
					}
				}
				else //no moneylimit
				{
					// abort session if verdopplung > 19
					if(verdopplung > 18)
					{
						int tempEintrag = 0;
						tempEintrag = list1.get(verdopplung);
						tempEintrag = tempEintrag+1;
						
						list1.set(verdopplung,tempEintrag);
						bar2.Ddataset.setValue(tempEintrag,bar2.seriesN[verdopplung],bar2.category1);
						
						//reset verdopplung
						verdopplung = 0;
						
						output("Session aborted. Bet amount too high!\n",set0);
						break;
					}					
				}
			}
							
			// print bet
			if(startColor == 1)
				output("RED\t",set2);
			else
				output("BLACK\t",set3);
			
			// print roulette
			if(number == 1)
			{
				output("RED\t",set2);
				statCountRed++;
			}
			else if(number == 2)
			{
				output("BLACK\t",set3);
				statCountBlack++;
			}
			else
			{
				output("ZERO\t",set6);
				statCountZero++;
			}
			
			
			if (prisonloop == false)
			{
				if (number == startColor)
				{
					// win bet
					budget = budget + betAmount;

					// deactivate lose
					lose = false;
					output("WIN", set4);
					output("\t" + budget, set1);
					output("\t" + defaultBetAmount + "\n", set1);
									
					// save last win (always defaultBetAmount)
					lastAutoBet = defaultBetAmount;
					
					// only print verdopplungen > 0 in bar
					if(verdopplung != 0)
					{
						int tempEintrag = 0;
						tempEintrag = list1.get(verdopplung);						
						tempEintrag = tempEintrag+1;
						
						list1.set(verdopplung,tempEintrag);
						bar2.Ddataset.setValue(tempEintrag,bar2.seriesN[verdopplung],bar2.category1);
					}
					
					//reset verdopplung
					verdopplung = 0;
					
					statCountWin++;
				}
				else if ((number != startColor) && (number != 0))
				{
					// lose bet
					budget = budget - betAmount;
					// double next betAmount
					betAmount = betAmount * 2;

					// activate lose
					lose = true;
					output("LOSE", set5);
					output("\t" + budget, set1);
					output("\t" + betAmount + "\n", set1);
					
					// save last lose
					lastAutoBet = betAmount;
					
					verdopplung++;
					
					statCountLose++;
				}
				else //null
				{
					// use En Prison
					prisonloop = true;					
					
					output("PRIS", set7);
					output("\t" + budget, set1);
					output("\t" + betAmount + "\n", set1);
					
					// special case if on fixed rounds the last round is a prison
					// use La Partage then
					if((sieg != 1)&&(j==(rounds-1)))
					{
						// get half of bet back
						budget = budget - (betAmount-betAmount/2);
						
						// deactivate prisonloop
						prisonloop = false;
						
						output("Prison on last round - La Partage: "+budget+"\n",set0);
						
						statCountPart++;
					}
				}
			}
			else // conditions in prisonloop
			{
				if (number == startColor)
				{
					// bet = lastBet
					betAmount = lastAutoBet;
					
					output("PWIN", set8);
					output("\t" + budget, set1);
					output("\t" + betAmount + "\n", set1);
													
					statCountPWin++;
				}
				else //null
				{
										
					// lose bet
					budget = budget - betAmount;
					// double next betAmount
					betAmount = betAmount * 2;
					
					// since PLOS == real LOSE, we must 
					// put this as lastAutoAmount
					lastAutoBet = betAmount;
					
					// activate lose
					lose = true;
					output("PLOS", set5);
					output("\t" + budget, set1);
					output("\t" + betAmount + "\n", set1);
					
					verdopplung++;
										
					statCountLose++;
				}
				
				// end prisonloop in any case
				prisonloop = false;
			}
			
			budgetField.setText(""+budget);
			
			if(sieg == 1)
			{
				if(Integer.parseInt(budgetField.getText())>=Integer.parseInt(autoGoal.getText()))
				{
					output("Money Goal reached!\n",set0);
					break;
				}
			}
		}
		
		// if earned more
		if(budget > budgetReset)
		{
			int tempEintragA = 0;
			tempEintragA = list2.get(0);
			tempEintragA = tempEintragA+1;
			list2.set(0,tempEintragA);
			bar3.Ddataset.setValue(tempEintragA,bar3.seriesMore,bar3.category1);
			
			int tempTotalG = Math.abs(budgetReset-budget);
			totalGewinn = tempTotalG+totalGewinn;
			bar4.Ddataset.setValue(totalGewinn,bar4.earned,bar4.category1);
		}
		else if(budget == budgetReset)
		{
			// even
			int tempEintragB = 0;
			tempEintragB = list2.get(1);
			tempEintragB = tempEintragB+1;
			list2.set(1,tempEintragB);
			bar3.Ddataset.setValue(tempEintragB,bar3.seriesEven,bar3.category1);
		}
		else	// less
		{
			int tempEintragX = 0;
			tempEintragX = list2.get(2);
			tempEintragX = tempEintragX+1;
			list2.set(2,tempEintragX);
			bar3.Ddataset.setValue(tempEintragX,bar3.seriesLess,bar3.category1);
			
			int tempTotalV = Math.abs(budgetReset-budget);
			totalVerlust = tempTotalV+totalVerlust;
			bar4.Ddataset.setValue(totalVerlust,bar4.lost,bar4.category1);
		}		
		
		budgetField.setText(""+budget);
		
		
		// set statistics
		bar1.Ddataset.setValue(statCountRed,bar1.series1,bar1.category1);
		bar1.Ddataset.setValue(statCountBlack,bar1.series2,bar1.category1);
		bar1.Ddataset.setValue(statCountZero,bar1.series3,bar1.category1);
		bar1.Ddataset.setValue(statCountWin,bar1.series4,bar1.category1);
		bar1.Ddataset.setValue(statCountLose,bar1.series5,bar1.category1);
		bar1.Ddataset.setValue(statCountPWin,bar1.series7,bar1.category1);
		bar1.Ddataset.setValue(statCountPart,bar1.series8,bar1.category1);
		
		// overall result
		totalResult = totalGewinn-totalVerlust;
		bar4.Ddataset.setValue(totalResult,bar4.result,bar4.category1);
		
		// print last duplication into bar
		if(verdopplung != 0)
		{
			int tempEintrag = 0;
			tempEintrag = list1.get(verdopplung);
			tempEintrag = tempEintrag+1;
			
			list1.set(verdopplung,tempEintrag);
			bar2.Ddataset.setValue(tempEintrag,bar2.seriesN[verdopplung],bar2.category1);
		}
	}
	
	public static void main(String[] args)
	{
		Font standard = new Font("Arial",Font.PLAIN,12);
		Font bold = new Font("Arial",Font.BOLD,12);
		Font big = new Font("Arial",Font.PLAIN,24);
		
		UIManager.put("Label.font",bold);
		UIManager.put("RadioButton.font",standard);
		UIManager.put("CheckBox.font",standard);
		UIManager.put("Button.font",standard);
		UIManager.put("TextField.font",big);
		
		Roulette roulette = new Roulette();
		roulette.setTitle("Roulette Statistics");
		roulette.setSize(900,645);
		roulette.setResizable(false);
		roulette.setLocationRelativeTo(null);
		roulette.setVisible(true);
	}
}